import math
import numpy
import re
import sys

if len(sys.argv) < 2:
	sys.exit('invalid number of arguments')

def trimmean(nums, k=2):
	nums = sorted(nums)
	return numpy.mean(nums[k:len(nums)-2*k])

def trimstd(nums, k=2):
	nums = sorted(nums)
	return numpy.std(nums[k:len(nums)-2*k])

with open(sys.argv[1], 'r') as infile:

	query = None
	query_no = -1
	query_type = None
	scale = None
	direction = None
	nums  = []

	print "scale, dir, type, query#, query, min, max, median, mean, stddev, mean (trimmed), stddev (trimmed)"
	for line in infile:

		line = line.strip()

		r = re.match('^(select .*)', line)
		if r:
			if query is not None:
				print "%(scale)d, %(direction)s, %(type)s, %(qno)d, %(query)s, %(min).3f, %(max).3f, %(median).3f, %(mean).3f, %(stddev).3f, %(tmean).3f, %(tstddev).3f" % {
						'query' : query,
						'min' : numpy.amin(nums),
						'max' : numpy.amax(nums),
						'mean'   : numpy.mean(nums),
						'stddev' : numpy.std(nums),
						'tmean' : trimmean(nums),
						'tstddev' : trimstd(nums),
						'median' : numpy.median(nums),
						'scale' : scale,
						'direction' : direction,
						'type' : query_type,
						'qno' : (query_no+1)
					}

			nums = []
			query = line

			query_no = (query_no + 1) % 3

			if re.search('desc', query):
				direction = 'desc'
			elif re.search('asc', query):
				direction = 'asc'
			else:
				direction = 'random'

			if re.search('float', query):
				query_type = 'float'
			elif re.search('text', query):
				query_type = 'text'
			elif re.search('int', query):
				query_type = 'int'
			elif re.search('numeric', query):
				query_type = 'numeric'

			continue

		r = re.match('======== scale ([0-9]+) ========', line)
		if r:
			scale = int(r.group(1))
			continue

		r = re.match('Time: ([0-9]+.[0-9]+) ms', line)
		if r:
			nums.append(float(r.group(1)))
			continue

	print "%(scale)d, %(direction)s, %(type)s, %(qno)d, %(query)s, %(min).3f, %(max).3f, %(median).3f, %(mean).3f, %(stddev).3f, %(tmean).3f, %(tstddev).3f" % {
			'query' : query,
			'min' : numpy.amin(nums),
			'max' : numpy.amax(nums),
			'mean'   : numpy.mean(nums),
			'stddev' : numpy.std(nums),
			'tmean' : trimmean(nums),
			'tstddev' : trimstd(nums),
			'median' : numpy.median(nums),
			'scale' : scale,
			'direction' : direction,
			'type' : query_type,
			'qno' : (query_no+1)
		}

